//+------------------------------------------------------------------+
//|                                     Fractals - adjustable period |
//+------------------------------------------------------------------+
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  Lime
#property indicator_color4  Gold
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  3
#property indicator_width4  3

//
//
//
//
//

extern int    FractalPeriod          = 22;
extern int    FractalPeriod_HTF      = 22;
extern int    PriceHigh              = PRICE_HIGH;
extern int    PriceLow               = PRICE_LOW;
extern double UpperArrowDisplacement = 2;
extern double LowerArrowDisplacement = 2;
extern int    TimeFrameHi            = 240;
extern bool   HTF_Fractal            = true;
extern bool   alertsOn               = false;
extern bool   alertsMessage          = true;
extern bool   alertsSound            = false;
extern bool   alertsEmail            = false;

double UpperBuffer[];
double LowerBuffer[];
double UpperBuffer1[];
double LowerBuffer1[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   if (MathMod(FractalPeriod,2)==0)
         FractalPeriod = FractalPeriod+1;
   SetIndexBuffer(0,UpperBuffer); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
   SetIndexBuffer(1,LowerBuffer); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,159);

   SetIndexBuffer(2,UpperBuffer1); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,116);
   SetIndexBuffer(3,LowerBuffer1); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,116);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{

   if (HTF_Fractal==true) HTF_Fractals(UpperBuffer1, LowerBuffer1);
                     
   int half = FractalPeriod/2;

   int i, bBars=WindowFirstVisibleBar(), limit= bBars-1;

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
         bool   found     = true;
         double compareTo = iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i);
         for (int k=1;k<=half;k++)
            {
               if ((i+k)<bBars && iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i+k)> compareTo) { found=false; break; }
               if ((i-k)>=0   && iMA(NULL,0,1,0,MODE_SMA,PriceHigh,i-k)>=compareTo) { found=false; break; }
            }
         if (found) 
               UpperBuffer[i]=High[i]+MarketInfo(Symbol(),MODE_SPREAD)*UpperArrowDisplacement*Point;
         else  UpperBuffer[i]=EMPTY_VALUE;

      //
      //
      //
      //
      //
      
         found     = true;
         compareTo = iMA(NULL,0,1,0,MODE_SMA,PriceLow,i);
         for (k=1;k<=half;k++)
            {
               if ((i+k)<bBars && iMA(NULL,0,1,0,MODE_SMA,PriceLow,i+k)< compareTo) { found=false; break; }
               if ((i-k)>=0   && iMA(NULL,0,1,0,MODE_SMA,PriceLow,i-k)<=compareTo) { found=false; break; }
            }
         if (found)
              LowerBuffer[i]=Low[i]-MarketInfo(Symbol(),MODE_SPREAD)*LowerArrowDisplacement*Point;
         else LowerBuffer[i]=EMPTY_VALUE;
   }
 
 
   //
   //
   //
   //
   //
   
   static datetime previousLevel = -1; static int previousSignal = 0;
   
   if (alertsOn)
   {
      int currentBar=-1;
               for (i=0; i<bBars-1; i++) if (LowerBuffer[i]!=EMPTY_VALUE || UpperBuffer[i]!=EMPTY_VALUE) { currentBar = i; break; }
      if (currentBar>-1) checkAlert(currentBar,previousLevel,previousSignal,UpperBuffer,LowerBuffer ,"");
   }

   //
   //
   //
   //
   //
   
   return(0);
}

//+------------------------------------------------------------------+
//|                                                             
//+------------------------------------------------------------------+
//
//
//
//
//

void checkAlert(int currentBar, datetime& previousLevel, int& previousSignal, double& upBuffer[], double& dnBuffer[], string text)
{
   int previousBar = iBarShift(NULL,0,previousLevel);
   int currentSignal;
         if (upBuffer[currentBar]!=EMPTY_VALUE)                                      currentSignal = -1;
         if (dnBuffer[currentBar]!=EMPTY_VALUE)                                      currentSignal =  1;
         if (dnBuffer[currentBar]!=EMPTY_VALUE && upBuffer[currentBar]!=EMPTY_VALUE) currentSignal =  0;

   //
   //
   //
   //
   //
   
   if (currentBar != previousBar || currentSignal != previousSignal)
   {
      if (currentSignal != previousSignal && currentBar > previousBar && previousLevel != -1)
            string alertText = "reverted to ";
      else         alertText = "current signal ";            
      switch(currentSignal)
      {
         case  0 : doAlert(text+alertText+"up/down"); break;
         case  1 : doAlert(text+alertText+"up");      break;
         case -1 : doAlert(text+alertText+"down");
      }               
 
      //
      //
      //
      //
      //
              
      previousLevel  = Time[currentBar];
      previousSignal = currentSignal;
   }
}

//
//
//
//
//

void doAlert(string doWhat)
{
   string message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Fractals ",doWhat);
      if (alertsMessage) Alert(message);
      if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"Fractals"),message);
      if (alertsSound)   PlaySound("alert2.wav");
}

//+------------------------------------------------------------------+
double HTF_Fractals(double& UpperBuffer1[],double& LowerBuffer1[])
{
   int half = FractalPeriod_HTF/2;

   int i, bBars=WindowFirstVisibleBar(), limit= bBars-1;

   //
   //
   //
   //
   //

   for(i=limit; i>=0; i--)
   {
         bool   found     = true;
         double compareTo = iMA(NULL,TimeFrameHi,1,0,MODE_SMA,PriceHigh,i);
         for (int k=1;k<=half;k++)
            {
               if ((i+k)<bBars && iMA(NULL,TimeFrameHi,1,0,MODE_SMA,PriceHigh,i+k)> compareTo) { found=false; break; }
               if ((i-k)>=0   && iMA(NULL,TimeFrameHi,1,0,MODE_SMA,PriceHigh,i-k)>=compareTo) { found=false; break; }
            }
         if (found) 
               UpperBuffer1[i]=iHigh(NULL,TimeFrameHi,i)+MarketInfo(Symbol(),MODE_SPREAD)*UpperArrowDisplacement*Point;
         else  UpperBuffer1[i]=EMPTY_VALUE;

      //
      //
      //
      //
      //
      
         found     = true;
         compareTo = iMA(NULL,TimeFrameHi,1,0,MODE_SMA,PriceLow,i);
         for (k=1;k<=half;k++)
            {
               if ((i+k)<bBars && iMA(NULL,TimeFrameHi,1,0,MODE_SMA,PriceLow,i+k)< compareTo) { found=false; break; }
               if ((i-k)>=0   && iMA(NULL,TimeFrameHi,1,0,MODE_SMA,PriceLow,i-k)<=compareTo) { found=false; break; }
            }
         if (found)
              LowerBuffer1[i]=iLow(NULL,TimeFrameHi,i)-MarketInfo(Symbol(),MODE_SPREAD)*LowerArrowDisplacement*Point;
         else LowerBuffer1[i]=EMPTY_VALUE;
   }

}

//+------------------------------------------------------------------+

